#!/usr/bin/python

##       (C) 2006 by Marki <marki{at}marki-online.net>, based on small python script by unknown author
######## Parameters
##       argv[1] ... domain name (virtual host) which is sending mail
##       argv[2] ... email address which should be set as sender [optional]

### TODO content filter -- paypal, ...

######## configuration --> please modify in file secure_sendmail_conf

import sys
import time
import MySQLdb
from secure_sendmail_conf import *
from secure_sendmail_mod import *
from datetime import datetime
from random import random
from popen2 import popen2

domain = sys.argv[1]
now = int(time.time())
dt = datetime.today().strftime("[%a %b %e %H:%M:%S %Y]") # [Sun Apr  9 06:26:03 2006]

### receive mail from stdin (this part written by unknown author)
data = ""
to = ""
l = sys.stdin.readline()
header = 1
while l:
     if string.find(l, 'To: ') == 0:
        to = string.strip(string.split(l, ':', 1)[1])
     if l == "\n" and header == 1:
        data += "X-Complaints-To: suuport@your_domain.com\n"
        data += "X-Abuse-Info: Email sent from customer's php script.\n"
        data += "X-Abuse-Info: Please be sure to forward a copy of ALL headers\n"
        data += "X-Abuse-Info: Otherwise we will be unable to process your complaint properly.\n"
        data += "X-Domain: %s\n\n" % domain
        header = 0
     else:
        data += l
     l = sys.stdin.readline()

### check limits
# dom_limit will be set to limits for current domain (default or specific if exist)
if minutes_limit.has_key(domain):
  dom_limit = minutes_limit[domain]
else:
  dom_limit = minutes_limit['default']

db = MySQLdb.connect(host="db.your_domain.com", user="dbuser", passwd=get_password('734jhsd%aQJ'), db="dbname", connect_timeout=2)
cur = db.cursor();
for min in minutes_check :
  tmp = str(now-60*min)
  cur.execute("SELECT COUNT(*) FROM php_sendmail WHERE `time` > %s AND `domain` = %s", (tmp,domain))
  row = cur.fetchone()
  lim = dom_limit[minutes_check.index(min)]
  if row[0] > lim :
    sys.stderr.write(dt+" [secure-sendmail] domain "+domain+": exceeded limit for "+str(min)+" minutes ("+str(lim)+")\n")
    time.sleep(sleep_val)
    sys.exit(1)
# done for

# limit not exceeded, send mail
cmd = '/usr/sbin/sendmail -t -i'
if len(sys.argv) == 3:
  cmd += " -f %s" % sys.argv[2]

(out, s) = popen2(cmd)
s.write(data)
s.close()

# log to sql
cur.execute("INSERT INTO php_sendmail SET `domain`=%s, `to`=%s, `time`=%s", (domain, to, now))

# gc - delete old records
if random() < gc_probab :
  gc_timelimit = now - (gc_delete*3600)
  cur.execute("DELETE FROM php_sendmail WHERE time < %s", (gc_timelimit,))
  sys.stderr.write(dt+" [secure-sendmail] GC was run (probability: "+str(gc_probab)+"; "+str(cur.rowcount)+" rows older than "+str(gc_delete)+" hours deleted)\n")

### end
